#!/usr/bin/perl

use FileHandle;
use IPC::Open3;
           
# collect arguments
@args = @ARGV;
$iarg = @args;

#find the user's home directory.
$dir = `echo ~`;
chop $dir;
$dir = $dir."/.dep";

if ($iarg==0) {
  print "Error!  Please at least provide program name you want to trace!\n";
  exit(0);
}

#init. local vars.
$debug=0;
$detail=0;
$counter=0;

$name = $args[0];
$flagcount=0;
$flag = $args[0];

while ($flag=~ /-/) {
  $name = $args[$flagcount+1];
  if ($flag eq "-debug") {
    $debug=1;
    $flagcount++;
  }
  if ($flag eq "-nokid") {
    $flagcount++;
  }
  if ($flag eq "-detail") {
    $detail=1;
    $flagcount++;
  }
  if ($flag eq "-list") {
    if (-e "$dir/$name") {
      open FROM, "$dir/$name";
      while ($line = <FROM>) {
	print $line;
      }
    }
    else {
      print "Error.  Can't find dep. file for $name.\n";
    }
    exit(0);
  } 
  if ($flag eq "-clear") {
    if (-e "$dir/$name") {
      unlink "$dir/$name";
    }
    else {
      print "Error.  Can't find dep. file for $name.\n";
    }
    exit(0);
  }
  if ($flag eq "-merge") {
    $name1 = $args[--$iarg];
    $name2 = $args[--$iarg];
    if ((-e "$dir/$name1") && (-e "$dir/$name2")){
      local @tmp;
      local %newlist;
      local $index;
      open FROM1, "$dir/$name1";
      open FROM2, "$dir/$name2";
      while ($line = <FROM1>) {
	chop $line;
	@tmp1 = split / /, $line;
	foreach $item (@tmp1) {
	  $newlist{$item}=1;
	}
      }
      while ($line = <FROM2>) {
	chop $line;
	@tmp1 = split / /, $line;
	foreach $item (@tmp1) {
	  $newlist{$item} = 1;
	}
      }
      close FROM1;
      close FROM2;
      sysopen NEW, "$dir/$name", O_RDWR|O_CREAT, 0700 or die "sysopen $path: $!";
      foreach $key (sort keys %newlist) {
	NEW->print($key." ");
      }
      NEW->print("\n");
      close NEW;
    }
    else {
      print "Error.  Can't find dep. file for $name1 or $name2.\n";
    }
    
    exit(0);
  }
  if ($flag eq "-move") {
    $name1 = $args[--$iarg];
    if (-e "$dir/$name1") {
      local @tmp;
      local $index;
      open FROM, "$dir/$name1";
      while ($line = <FROM>) {
	@tmp1 = split / /, $line;
	  @tmp = (@tmp, @tmp1);
      }
      $index=@tmp;
      close FROM;
      unlink "$dir/$name1";
      sysopen NEW, "$dir/$name", O_RDWR|O_CREAT, 0700 or die "sysopen $path: $!";
      while ((--$index)>=0) {
	NEW->print($tmp[$index]." ");
      }
      NEW->print("\n");
      close NEW;
    }
    else {
      print "Error.  Can't find dep. file for $name1.\n";
    }
    exit(0);
  }
  if ($flag eq "-copy") {
    $name1 = $args[--$iarg];
    if (-e "$dir/$name1") {
      local @tmp;
      local $index;
      open FROM, "$dir/$name1";
      while ($line = <FROM>) {
	@tmp1 = split / /, $line;
	@tmp = (@tmp, @tmp1);
      }
      $index=@tmp;
      close FROM;
      sysopen NEW, "$dir/$name", O_RDWR|O_CREAT, 0600 or die "sysopen $path: $!";
      while ((--$index)>=0) {
	NEW->print($tmp[$index]." ");
      }
      NEW->print("\n");
      close NEW;
    }
    else {
      print "Error.  Can't find dep. file for $name1.\n";
    }
    exit(0);
  }
  $flag = $args[$flagcount];
}

#assume dep already created the tmp dep file.
open FROM, "/tmp/tmp.$name.dep";

while ($line = <FROM>) {
  
  # right now only pick up "open" and "execve".
  if (($line =~ /open\(\"(.*)\".*= \d+/) || 
      ($line =~ /execve\(\"([^\"]*)\".*= \d+/)) {
    @path = split /\//, $1;
    $level = @path;
    $filename = $path[$level-1];
    if ($filename ne ".." && $filename ne ".") {
      $pack = `rpm -qf --queryformat \"%{name}-%{version}-%{release}\" $1 2>/dev/null`;
      
      if ($setname = $pack) {
	$setname=$setname."::".$1;
	$list{$setname} = 1;
      }
      else {
	$list{$1} = 1;
      }
    }
  }
}

close FROM;

if (-e "$dir/$name") {
  open FROM, "$dir/$name";
  while ($line = <FROM>) {
    chop $line;
    chop $line;
    if ($list{$line}==0) {
      $list{$line}=1;
    }
  }
}

close FROM;

if (-d $dir) {
  if (-w $dir) {
  }
  else {
    print "Error.  Can't write to .dep dir!\n";
  }
}
else {
  if ($debug==1) {
    print "create dir ~/.dep\n";
  }
  `mkdir ~/.dep`;
}

if ($debug==1) {
  print "\n";
}

$fullpath = "$dir/$name";

sysopen OUTFILE, $fullpath, O_RDWR|O_CREAT, 0700 or die "sysopen $path: $!";

foreach $key (sort keys %list) {
  OUTFILE->print($key." \n");
  if ($detail==0) {
    if ($key =~ /([^-]*)-/) {
      if ($bag{$1}==0) {
	$bag{$1}=1;
	print $1." \n";
      }
    }
    else {
      print $key." \n";
    }
  }
  else {
    print $key." \n";
  }    
}

print "\n";

close OUTFILE;

unlink "/tmp/tmp.$name.dep";
